#include<iostream>
#include <thread>
#include <mutex> 

#ifdef DEBUG
#define TEMP_DEBUG
#endif

#include <easylogging++.h>
_INITIALIZE_EASYLOGGINGPP

#ifdef TEMP_DEBUG
#define DEBUG
#undef TEMP_DEBUG
#endif


#ifdef EARLY_TEMPLATE
#define __EXECUTABLE__
#ifdef __GNUG__
#include <raslib/template_inst.hh>
#endif
#endif
#include <rasdaman.hh>
#include <rasodmg/database.hh>
#include <rasodmg/partinsert.hh>

enum State{
  UNINIT,
  READY,
  FAILED, 
};

r_Database db;
State t1;
State t2;

std::unique_ptr<r_Transaction> create_transaction(){
  std::unique_ptr<r_Transaction> t(new r_Transaction());
  t->begin();
  return t;
}

void insert_something_with_transaction(bool commit, State *which,
                                       std::string name, double value){
 std::unique_ptr<r_Transaction> t;
  try{
    std::cout << "Try init transaction" << std::endl;
    t = create_transaction();
  }catch(const r_Error &e){
    std::cout << "Error" << std::endl;
    *which = FAILED;
    return;
  } 
  *which = READY;
  std::cout << "One Ready" << std::endl;
    
  std::string query = "create collection " +name+" DoubleSet";
  r_OQL_Query create(query.c_str());
  r_Set<r_Ref_Any> result;
  r_oql_execute(create);

  query = "insert into " + name + " values marray x in [ 0:100, 0:100 ]values " + std::to_string(value);
  r_OQL_Query insert(query.c_str());
  r_oql_execute(insert);
    
  if (commit){
    t->commit();
  }else{
    t->abort();
  }
 
}


void run() {
  while (true){
    t1 = UNINIT;
    t2 = UNINIT;
    auto a = std::thread(insert_something_with_transaction, false, &t1, "A", 0.0);
    auto b = std::thread(insert_something_with_transaction, true, &t2, "B", 42.0);
    a.join();
    b.join();
    if(t1 == READY && t2 == READY){
      std::cout << "ready" << std::endl;
      break;
    }
  }
}

int main(void){
  easyloggingpp::Configurations defaultConf;
  defaultConf.setToDefault();
  defaultConf.setAll(easyloggingpp::ConfigurationType::ToStandardOutput, "false");
  defaultConf.setAll(easyloggingpp::ConfigurationType::Enabled, "false");
  easyloggingpp::Loggers::reconfigureAllLoggers(defaultConf);
  
  db.set_servername("localhost", 7001);
  db.set_useridentification("rasadmin", "rasadmin");
  db.open("RASBASE");
  run();
  

  return 0;
}
